
<script>

import { ask_for_list_of_treasures } from '$lib/mongo/treasures/itemize.mongo.js'
import { onMount, onDestroy } from 'svelte'
import { filter_treasures_by_domain } from '$lib/treasures/filter/by_domain'
import { ask_treasure_to_trend } from '$lib/mongo/treasures/ask_treasure_to_trend.mongo.js'
import { has_field } from 'procedures/object/has_field'
	
let original_treasures = [];
let treasures = []
let similarities = []

let domain_filter = "";
$: {
	let _domain_filter = domain_filter;
	filter_sort ();
}

import Similarity from './Similarity.svelte'

const filter_sort = () => {
	treasures = filter_treasures_by_domain ({ domain_filter, treasures: original_treasures });
	// similarities = retrieve_similarities (treasure)
}

const build = async () => {
	original_treasures = []
	
	const { enhanced } = await ask_for_list_of_treasures ();	
	original_treasures = enhanced.treasures;
	filter_sort ();
}



onMount (async () => {
	build ();
});

const move_to_trends = ({ treasure }) => {
	return async () => {
		console.log ("move_to_trends:", { treasure });
		
		
		let similar = []
		if (
			has_field (treasure, "bracket") &&
			has_field (treasure.bracket, "similar") &&
			Array.isArray (treasure.bracket.similar)
		) {
			similar = treasure.bracket.similar;
		}
		
		const { enhanced } = await ask_treasure_to_trend ({
			domain: treasure.domain,
			similar
		});
		
		build ();
	}
}


const delete_treasure = ({ treasure }) => {
	return async () => {
		console.log ("delete_treasure:", { treasure });

	}
}


</script>

<div>
	<header>treasures</header>
	
	<div class="card p-4">
		<label class="label">
			<span>Name Filter</span>
			<input 
				style="
					padding: 0.1cm 0.5cm;
				"
				class="input" type="text" 
				placeholder=""
				bind:value={ domain_filter }
			/>
		</label>
	</div>
	
	{#each treasures as treasure }
	<div
		class="card"
		style="
			margin: 12px 0;
			padding: 12px;
			
			display: flex;
			align-items: center;
			justify-content: space-between;
			flex-direction: row;
			
			gap: 6px;
		"
	>
		<div
			
			style="
				width: 100%;
			"
			class="card p-2 variant-soft-primary"
		>
			<div>
				<span class="badge variant-soft-primary">
					<span>domain</span>
					<span class="badge variant-filled-primary">{ treasure.domain }</span>
				</span>
			</div>
			
			<div style="height: 4px" />
			
			<Similarity treasure={ treasure }/>
		</div>
		
		
		<div 
			style="
				width: 2px;
				height: 100%;
				background: rgb(var(--color-surface-300);
				border-radius: 50px;
				
				margin: 8px 0;
			"
			
		/>
		
		<div
			style="
				align-item: right;
			"
			class="card p-2 variant-soft-primary"
		>
			<div
				style="
					text-align: right;
				"
			>
				<button 
					type="button" 
					class="btn btn-sm variant-filled"
					on:click={ move_to_trends ({ treasure }) }	
				>Move to Trends</button>
			</div>

			<div style="height: 12px" />
	
			<div
				style="
					display: none;
					text-align: right;
				"
			>
				<button 
					type="button" 
					on:click={ delete_treasure ({ treasure }) }	
					
					class="btn btn-sm variant-filled-error"
					
				>Delete</button>
			</div>
		</div>
	</div>
	{/each}
</div>

